# javascript-problems-and-solutions

[![npm version](https://badge.fury.io/js/javascript-problems-and-solutions.svg)](https://badge.fury.io/js/javascript-problems-and-solutions)
[![Build Status](https://travis-ci.org/jeantimex/javascript-problems-and-solutions.svg?branch=master)](https://travis-ci.org/jeantimex/javascript-problems-and-solutions)
[![Coverage Status](https://coveralls.io/repos/github/jeantimex/javascript-problems-and-solutions/badge.svg?branch=code-coverage)](https://coveralls.io/github/jeantimex/javascript-problems-and-solutions?branch=code-coverage)
[![devDependencies Status](https://david-dm.org/jeantimex/javascript-problems-and-solutions/dev-status.svg)](https://david-dm.org/jeantimex/javascript-problems-and-solutions?type=dev)
[![Donate](https://img.shields.io/badge/Donate-PayPal-green.svg)](https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=BFXQGY77CV3T2)

A collection of JavaScript problems and solutions for studying algorithms.

![cover](docs/images/cover.png)

## Problems

### Tree

- [Balanced Binary Tree](src/tree/balanced-binary-tree.js)
- [Binary Tree Preorder Traversal](src/tree/binary-tree-preorder-traversal.js)
- [Binary Tree Inorder Traversal](src/tree/binary-tree-inorder-traversal.js)
- [Binary Tree Postorder Traversal](src/tree/binary-tree-postorder-traversal.js)
- [Binary Tree Level Order Traversal](src/tree/binary-tree-level-order-traversal.js)
- [Binary Tree Longest Consecutive Sequence](src/tree/binary-tree-longest-consecutive-sequence.js)
- [Binary Tree Maximum Path Sum](src/tree/binary-tree-maximum-path-sum.js)
- [Binary Tree Paths](src/tree/binary-tree-paths.js)
- [Binary Tree Upside Down](src/tree/binary-tree-upside-down.js)
- [Binary Tree Zigzag Level Order Traversal](src/tree/binary-tree-zigzag-level-order-traversal.js)
- [Closest Binary Search Tree Value](src/tree/closest-binary-search-tree-value.js)
- [Closest Binary Search Tree Value II](src/tree/closest-binary-search-tree-value-ii.js)
- [Construct Binary Tree From Postorder and Inorder Traversal](src/tree/construct-binary-tree-from-inorder-and-postorder-traversal.js)
- [Construct Binary Tree From Preorder and Inorder Traversal](src/tree/construct-binary-tree-from-preorder-and-inorder-traversal.js)
- [Convert Sorted Array to Binary Search Tree](src/tree/convert-sorted-array-to-binary-search-tree.js)
- [Count Univalue Subtrees](src/tree/count-univalue-subtrees.js)
- [Flatten Binary Tree to Linked List](src/tree/flatten-binary-tree-to-linked-list.js)
- [Inorder Predecessor in BST](src/tree/inorder-predecessor-in-bst.js)
- [Inorder Successor in BST](src/tree/inorder-successor-in-bst.js)
- [Lowest Common Ancestor of A Binary Search Tree](src/tree/lowest-common-ancestor-of-a-binary-search-tree.js)
- [Lowest Common Ancestor of a Binary Tree](src/tree/lowest-common-ancestor-of-a-binary-tree.js)
- [Maximum Depth of Binary Tree](src/tree/maximum-depth-of-binary-tree.js)
- [Minimum Depth of Binary Tree](src/tree/minimum-depth-of-binary-tree.js)
- [Path Sum](src/tree/path-sum.js)
- [Path Sum II](src/tree/path-sum-ii.js)
- [Path Sum III](src/tree/path-sum-iii.js)
- [Populating Next Right Pointers in Each Node](src/tree/populating-next-right-pointers-in-each-node.js)
- [Populating Next Right Pointers in Each Node II](src/tree/populating-next-right-pointers-in-each-node-ii.js)
- [Recover Binary Search Tree](src/tree/recover-binary-search-tree.js)
- [Same Tree](src/tree/same-tree.js)
- [Serialize and Deserialize Binary Tree](src/tree/serialize-and-deserialize-binary-tree.js)
- [Sum Root to Leaf Numbers](src/tree/sum-root-to-leaf-numbers.js)
- [Symmetric Tree](src/tree/symmetric-tree.js)
- [Unique Binary Search Trees](src/tree/unique-binary-search-trees.js)
- [Unique Binary Search Trees II](src/tree/unique-binary-search-trees-ii.js)
- [Univalue Tree](src/tree/univalue-tree.js)
- [Validate Binary Search Tree](src/tree/validate-binary-search-tree.js)
- [Verify Preorder Sequence in Binary Search Tree](src/tree/verify-preorder-sequence-in-binary-search-tree.js)
- [Delete Node in a BST](src/tree/delete-node-in-a-bst.js)
- [House Robber III](src/tree/house-robber-iii.js)
- [Diameter of Binary Tree](src/tree/diameter-of-binary-tree.js)
- [Trim a Binary Search Tree](src/tree/trim-a-binary-search-tree.js)
- [Maximum Binary Tree](src/tree/maximum-binary-tree.js)
- [Convert BST to Greater Tree](src/tree/convert-bst-to-greater-tree.js)
- [Find Mode in Binary Search Tree](src/tree/find-mode-in-binary-search-tree.js)
- [Find Bottom Left Tree Value](src/tree/find-bottom-left-tree-value.js)

### Dynamic Programming

- [Longest Increasing Subsequence](src/dynamic-programming/longest-increasing-subsequence.js)

## Author

I solve algorithm problems using JavaSript and Java, you can find all my LeetCode solutions and posts [here](https://discuss.leetcode.com/user/jeantimex).

## LICENSE

MIT License

Copyright (c) 2017 Yong Su @jeantimex

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
